#include "Fanout.h"

extern PegBitmap gbfoBitmap;

Fanout::Fanout(PegRect rect, CPMainFrame* frame):CPModuleWindow(rect,0,0,frame)
{
init();
}

int Fanout::init()
{   
   	const WORD wStyle = FF_NONE|TJ_LEFT|AF_TRANSPARENT| TT_COPY;
	const SIGNED margin = 10;
	const SIGNED width=mClient.Width()-2*margin;
    
    int hpos = 70-15;
    
    PegRect rectangle;
 
    rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_TOP+65);
 	PegBitmapButton * imatge = new PegBitmapButton(rectangle,&gbfoBitmap,0,AF_TRANSPARENT,TYPE_PROMPT,FALSE);
 	AddR(imatge); 
 	
 	PegPrompt* label1 = new PegPrompt(margin, hpos+=15 , width, "Vil:",0,wStyle);
 	PegPrompt* label2 = new PegPrompt(margin+width/2, hpos, width, "Vih:",0,wStyle);
 	PegPrompt* label3 = new PegPrompt(margin, hpos+=15, width, "Vol:",0,wStyle);
 	PegPrompt* label4 = new PegPrompt(margin+width/2, hpos, width, "Voh:",0,wStyle);
 	PegPrompt* label5 = new PegPrompt(margin, hpos+=15, width, "Iil:",0,wStyle);
 	PegPrompt* label6 = new PegPrompt(margin+width/2, hpos, width, "Iih:",0,wStyle);
 	PegPrompt* label7 = new PegPrompt(margin, hpos+=15, width, "Iol:",0,wStyle);
 	PegPrompt* label8 = new PegPrompt(margin+width/2, hpos, width, "Ioh:",0,wStyle);
 	PegPrompt* label9 = new PegPrompt(margin, hpos+=15, width, "Vcc:",0,wStyle);
 	PegPrompt* label10 = new PegPrompt(margin+width/2, hpos, width, "FO:",0,wStyle);
 	
	AddR(label1);
	AddR(label2);
	AddR(label3);
	AddR(label4);
	AddR(label5);
	AddR(label6);
	AddR(label7);
	AddR(label8);
	AddR(label9);
	AddR(label10);
            
    hpos = 70-15;
    vil = new CPPegString(32,hpos+=15,width/2-35,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
    vol = new CPPegString(32,hpos+=15,width/2-35,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
    iil = new CPPegString(32,hpos+=15,width/2-35,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
    iol = new CPPegString(32,hpos+=15,width/2-35,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
    Vcc = new CPPegString(32,hpos+=15,width/2-35,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
    hpos = 70-15;
    vih = new CPPegString(34+width/2,hpos+=15,width/2-35,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
    voh = new CPPegString(34+width/2,hpos+=15,width/2-35,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
    iih = new CPPegString(34+width/2,hpos+=15,width/2-35,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
    ioh = new CPPegString(34+width/2,hpos+=15,width/2-35,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
    FO = new CPPegString(34+width/2,hpos+=15,width/2-35,"",0, FF_THIN|AF_ENABLED|EF_EDIT);

 	AddR(vil);   
 	AddR(vol);   
 	AddR(vih);   
 	AddR(voh);   
 	AddR(iil);   
 	AddR(iol);   
 	AddR(iih);   
 	AddR(ioh);   
  	AddR(Vcc);   
 	AddR(FO);         	
	
 	PegPrompt* label11 = new PegPrompt(margin, hpos+=20, width, "Calcular:",0,wStyle);
    AddR(label11);

     //rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_BOTTOM);
    rectangle.Set(60, 150, 95, 165);
   	PegTextButton* b3 = new PegTextButton(rectangle, "Rpull", BOTO, AF_ENABLED|TJ_CENTER);
	AddR(b3);

    rectangle.Set(100, 150, 145, 165);
   	PegTextButton* b4 = new PegTextButton(rectangle, "FO_max", BOTO2, AF_ENABLED|TJ_CENTER);
	AddR(b4);
    
   	resultat = new PegPrompt(margin, 175 , width, "",0,wStyle);
	AddR(resultat);
 	
	return 0;
}

void Fanout::Draw()
{
	BeginDraw();
	Invalidate(mClient);
	DrawFrame();
	DrawChildren();
	EndDraw();
}

SIGNED Fanout::Message(const PegMessage &Mesg)
{
	switch(Mesg.wType)
	{
		case SIGNAL(BOTO, PSF_CLICKED):
		{
             CalculaRpull();
		}
		break;
		case SIGNAL(BOTO2, PSF_CLICKED):
		{
             CalculaFOmax();
		}
		break;	
        	
		default:
		return CPModuleWindow::Message(Mesg);
	}
	return 0;
}

WORD Fanout::Dialog(char* title, char* message)
{
	PegRect rr = GetMainFrame()->TopAppRectangle();
	rr.wBottom -= 30;
	rr.wRight -= 10;
	rr.wTop += 10;
	rr.wLeft += 10;
	PegMessageWindow *msg = new PegMessageWindow(rr, title, message, MW_OK, 0,0,0);
	return msg->Execute();
}

void Fanout::CalculaRpull()
{
    obcd aux,aux2,aux3;
   	PEGCHAR* chrohm = "\xEC\x7E";    
    
    // Mirar que se cumpla 
    // |IOLmax| > FO |IILmax|
    aux = CPExpression(iil->DataGet());
    Cal_abs_OBC(&aux);
    aux2 = CPExpression(iol->DataGet());
    Cal_abs_OBC(&aux2);
    aux3 = CPExpression(FO->DataGet());
    Cal_abs_OBC(&aux3);
    Cal_mul_OBC(&aux,&aux3);
    if(aux2 < aux)
    {
        resultat->DataSet("FO demasiado grande");
    }
    else
    {
       // Mirar que se cumpla 
       //|IOHmax| > FO |IIHmax|
       aux = CPExpression(iih->DataGet());
       Cal_abs_OBC(&aux);
       aux2 = CPExpression(ioh->DataGet());
       Cal_abs_OBC(&aux2);
       Cal_mul_OBC(&aux,&aux3);
       if(aux2 < aux)
       {
         resultat->DataSet("FO demasiado grande");
       }
       else
       {
           // Mirar si VOHmin > VIHmin
         aux = CPExpression(voh->DataGet());
         aux2 =  CPExpression(vih->DataGet());
         if(aux < aux2)
         {
             // Rpull-up needed
             // suponiendo corriente por R = 5mA
             aux = CPExpression(Vcc->DataGet());
             ExecuteToOBCD("0.005",aux2);
             Cal_div_OBC(&aux,&aux2);
             aux2 = ceiling(aux);
             if(aux2<=1000)
                resultat->DataSet("Rpull-up (Ru): "+CPString(aux2)+" "+CPString(chrohm));
             else
             {
                 ExecuteToOBCD("1000",aux);
                 Cal_div_OBC(&aux2,&aux);
                 aux = ceiling(aux2);
                 resultat->DataSet("Rpull-up (Ru): "+CPString(aux)+" k"+CPString(chrohm));
             }        
         }
         else
         {
            // Mirar si VOLmax < VILmax
            aux = CPExpression(vol->DataGet());
            aux2 =  CPExpression(vil->DataGet());
            if(aux > aux2)
            {
                // Rpull-down needed
                // Suponiendo TTL => 5V
                // Suponiendo corriente por R = 5mA
                resultat->DataSet("Rpull-down (Rd): 1 k"+CPString(chrohm));

            }
            else
            {
                resultat->DataSet("No hace falta Rd ni Ru");
            }   
         }
       }    
    }    
    
    
    Draw();
}   

void Fanout::CalculaFOmax()
{
    obcd aux,aux2,aux3;
    
    // |IOLmax| > FO |IILmax|
    aux = CPExpression(iil->DataGet());
    Cal_abs_OBC(&aux);
    aux2 = CPExpression(iol->DataGet());
    Cal_abs_OBC(&aux2);
    Cal_div_OBC(&aux2,&aux);
    aux3 = aux2;
    
    //|IOHmax| > FO |IIHmax|
    aux = CPExpression(iih->DataGet());
    Cal_abs_OBC(&aux);
    aux2 = CPExpression(ioh->DataGet());
    Cal_abs_OBC(&aux2);
    Cal_div_OBC(&aux2,&aux);
    
    if(aux2 < aux3) aux3 = aux2;
    
    aux = floor(aux3);
    
    resultat->DataSet("FO maximo: "+CPString(aux));
    
    Draw();
} 

extern "C" char *ExtensionGetLang(ID_MESSAGE MessageNo)
{
return "";
}
